--- otp_src_R12B-5/erts/emulator/beam/bif.tab.orig	2008-11-18 00:20:30.000000000 -0800
+++ otp_src_R12B-5/erts/emulator/beam/bif.tab	2008-11-18 00:21:42.000000000 -0800
@@ -726,6 +726,13 @@
 bif unicode:characters_to_list/2
 
 #
+# New Bifs in R13B-0
+#
+bif erlang:atom_to_binary/1
+bif erlang:binary_to_atom/1
+bif erlang:binary_to_existing_atom/1
+
+#
 # Obsolete
 #
 
--- otp_src_R12B-5/erts/emulator/beam/binary.c.orig	2008-11-18 00:39:49.000000000 -0800
+++ otp_src_R12B-5/erts/emulator/beam/binary.c	2008-11-18 01:29:35.000000000 -0800
@@ -663,3 +663,55 @@
     DESTROY_ESTACK(s);
     return (Sint) -1;
 }
+
+BIF_RETTYPE binary_to_atom_1(BIF_ALIST_1)
+{
+    Eterm res;
+    Uint size;
+    byte *buf;
+    byte *temp_alloc = NULL;
+
+    buf = erts_get_aligned_binary_bytes(BIF_ARG_1, &temp_alloc);
+    if (buf == NULL) {
+	BIF_ERROR(BIF_P, BADARG);
+    }
+    size = binary_size(BIF_ARG_1);
+    res = am_atom_put((const char *) buf, size);
+    erts_free_aligned_binary_bytes(temp_alloc);
+    BIF_RET(res);
+}
+
+BIF_RETTYPE binary_to_existing_atom_1(BIF_ALIST_1)
+{
+    Eterm res;
+    Uint size;
+    byte *buf;
+    byte *temp_alloc = NULL;
+    int got;
+
+    buf = erts_get_aligned_binary_bytes(BIF_ARG_1, &temp_alloc);
+    if (buf == NULL) {
+    error:
+	BIF_ERROR(BIF_P, BADARG);
+    }
+    size = binary_size(BIF_ARG_1);
+    got = erts_atom_get((const char *) buf, size, &res);
+    erts_free_aligned_binary_bytes(temp_alloc);
+    if (!got) {
+        goto error;
+    }
+    BIF_RET(res);
+}
+
+BIF_RETTYPE atom_to_binary_1(BIF_ALIST_1)
+{
+    Atom* ap;
+    Eterm bin;
+
+    if (is_not_atom(BIF_ARG_1)) {
+	BIF_ERROR(BIF_P, BADARG);
+    }
+    ap = atom_tab(atom_val(BIF_ARG_1));
+    bin = new_binary(BIF_P, ap->name, ap->len);
+    BIF_RET(bin);
+}
